#Wave running

execute if entity @e[tag=host,limit=1,scores={gameStatus=1}] run scoreboard players add @e[tag=host,limit=1] mr_enemy_timer 1
execute if entity @e[tag=host,limit=1,scores={gameStatus=1,mr_enemy_timer=1200..}] run scoreboard players set @e[tag=host,limit=1] mr_enemy_timer 0

execute if entity @e[tag=host,limit=1] run scoreboard players add @e[tag=host,limit=1] ally.anim_tick 1
execute if entity @e[tag=host,limit=1,scores={ally.anim_tick=30..}] run scoreboard players set @e[tag=host,limit=1] ally.anim_tick 0

bossbar set wave-mustkill visible true
execute store result bossbar wave-mustkill value run scoreboard players get @e[tag=host,limit=1] mr_enemy_deaths
execute unless entity @e[tag=boss] run bossbar set wave-mustkill name ["",{"text":"<< ","bold":true,"color":"dark_aqua"},{"text":"Wave","bold":false,"color":"#B8A375","font":"dwarvesc"},{"text":" ","color":"dark_aqua"},{"score":{"name":"@e[tag=host,limit=1]","objective":"md_wave"},"color":"dark_aqua"},{"text":" // Defeat","bold":false,"color":"#B8A375","font":"dwarvesc"},{"text":" ","color":"yellow"},{"score":{"name":"@e[tag=host,limit=1]","objective":"mr_enemy_deaths"},"color":"dark_aqua"},{"text":" more enemies! ","color":"#B8A375","font":"dwarvesc"},{"text":">>","bold":true,"color":"dark_aqua"}]
execute if entity @e[tag=boss] run bossbar set wave-mustkill name ["",{"text":"<< ","bold":true,"color":"dark_aqua"},{"text":"Wave","bold":false,"color":"#B8A375","font":"dwarvesc"},{"text":" ","color":"dark_aqua"},{"score":{"name":"@e[tag=host,limit=1]","objective":"md_wave"},"color":"dark_aqua"},{"text":" // Defeat","bold":false,"color":"#B8A375","font":"dwarvesc"},{"text":" ","color":"yellow"},{"score":{"name":"@e[tag=host,limit=1]","objective":"mr_enemy_deaths"},"color":"dark_aqua"},{"text":" more enemies and The Boss! ","color":"#B8A375","font":"dwarvesc"},{"text":">>","bold":true,"color":"dark_aqua"}]

#effect players with battle weakness
function myrunir:battle-weakness

#Shift spawn markers to its pivots
execute as @e[tag=enemyspawn,tag=pivoted_1,type=marker] at @s run tp @s ^ ^ ^0.3 facing entity @e[tag=spawn_pivot1,limit=1,sort=nearest]
execute as @e[tag=enemyspawn,tag=pivoted_2,type=marker] at @s run tp @s ^ ^ ^0.3 facing entity @e[tag=spawn_pivot2,limit=1,sort=nearest]

execute as @e[tag=enemyspawn,tag=pivoted_2,type=marker] at @s if entity @e[tag=spawn_pivot2,limit=1,sort=nearest,distance=..2] run tag @s add pivoted_1
execute as @e[tag=enemyspawn,tag=pivoted_2,type=marker] at @s if entity @e[tag=spawn_pivot2,limit=1,sort=nearest,distance=..2] run tag @s remove pivoted_2

execute as @e[tag=enemyspawn,tag=pivoted_1,type=marker] at @s if entity @e[tag=spawn_pivot1,limit=1,sort=nearest,distance=..2] run tag @s add pivoted_2
execute as @e[tag=enemyspawn,tag=pivoted_1,type=marker] at @s if entity @e[tag=spawn_pivot1,limit=1,sort=nearest,distance=..2] run tag @s remove pivoted_1

#execute as @e[type=#enemyspawn] at @s run particle angry_villager ~ ~ ~ 0 0 0 1 1 force

#Spawn waves of enemies on fixed spawn locations

#count enemy

execute at @e[tag=fix-enemy-spawn-1,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=10}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-summon-specific
execute at @e[tag=fix-enemy-spawn-1,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=400}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-summon-specific
execute at @e[tag=fix-enemy-spawn-1,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=800}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-summon-specific

execute at @e[tag=fix-enemy-spawn-2,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=200}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-summon-specific
execute at @e[tag=fix-enemy-spawn-2,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=650}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-summon-specific
execute at @e[tag=fix-enemy-spawn-2,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=1050}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-summon-specific

#Spawn hordes of enemies on random spawn location
execute at @e[tag=enemyspawn_1,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=0}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-summon-specific
execute at @e[tag=enemyspawn_1,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=300}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-summon-specific
execute at @e[tag=enemyspawn_1,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=600}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-summon-specific

execute at @e[tag=enemyspawn_2,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=100}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-summon-specific
execute at @e[tag=enemyspawn_2,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=500}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-summon-specific
execute at @e[tag=enemyspawn_2,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=1000}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-summon-specific

#Spawn hordes of random enemies with Siege tag on South Wall (RARE)
execute at @e[tag=fix-enemy-spawn-3,type=marker] if entity @e[tag=host,limit=1,scores={mr_enemy_timer=100}] if score @e[tag=host,limit=1] mr_enemy_count < @e[tag=host,limit=1] mr_max_enemies run function myrunir:wave-generic-random-summon-siege

#Rare miniboss Summons
execute if entity @e[tag=host,limit=1,scores={mr_enemy_timer=10}] run function myrunir:wave-miniboss

#Boss summon
execute if entity @e[tag=host,limit=1,scores={mr_enemy_timer=100},tag=!boss_summoned] run function myrunir:wave-boss

#Reset enemy lures evey 600 ticks
execute if entity @e[tag=host,limit=1,scores={mr_enemy_timer=600}] run tag @e remove lured
execute if entity @e[tag=host,limit=1,scores={mr_enemy_timer=1200}] run tag @e remove lured
execute if entity @e[tag=host,limit=1,scores={mr_enemy_timer=600}] run function myrunir:enemy_count
execute if entity @e[tag=host,limit=1,scores={mr_enemy_timer=1200}] run function myrunir:enemy_count

kill @e[type=trident,nbt={pickup:0b,inGround:1b}]
