#executed from mgice_core (armor_stand)

#particles
execute as @e[tag=aj.mandragigas.bone.eyes] at @s run particle snowflake ~ ~2 ~ 1.5 1.5 1.5 0.1 2 force
data modify entity @e[type=elder_guardian,tag=mgice_entity,limit=1,sort=nearest] Fire set value 0

# hp
execute store result score mgice boss.storage.mgice run data get entity @e[tag=mgice_entity,limit=1,sort=nearest] Health
# hurt
execute at @e[tag=mgice_entity,type=elder_guardian,tag=hurt] run playsound minecraft:block.grass.break hostile @a[distance=..30] ~ ~ ~ 1 0 0
execute at @e[tag=mgice_entity,type=elder_guardian,tag=hurt] run particle angry_villager ~ ~ ~ 0 0 0 0.3 1 force

# stop animate after spawning
execute if score mgice boss.battle_tick matches 0 as @e[tag=mandragigas.root] at @s run function mandragigas:animations/spawn/stop

# tp hitbox entity to eye
tp @e[tag=mgice_entity,limit=1,sort=nearest,type=elder_guardian] @e[tag=aj.mandragigas.bone.eyes,limit=1,sort=nearest]

# score add and score resets
scoreboard players add mgice boss.battle_tick 1
execute if entity @e[tag=mgice_entity,type=elder_guardian,distance=..10] if score mgice boss.battle_tick matches 500.. run scoreboard players set mgice boss.battle_tick 1
execute if score mgice boss.battle_tick matches 250 run tag @e remove mgice_target
execute if score mgice boss.battle_tick matches 499 run tag @e remove mgice_target

#music
execute if score mgice boss.mgice.music matches 1.. run scoreboard players remove mgice boss.mgice.music 1
execute if score mgice boss.mgice.music matches 0 run playsound minecraft:boss.worldboss.theme record @a[distance=..50] ~ ~ ~ 0.7 1 0.7
execute if score mgice boss.mgice.music matches 0 run scoreboard players set mgice boss.mgice.music 3120

# attack randomizer
execute if score worldScore wtc_10 matches 9.. if score mgice ally.anim_tick matches ..5 run scoreboard players add mgice ally.anim_tick 1
execute if score worldScore wtc_10 matches 9.. if score mgice ally.anim_tick matches 5.. run scoreboard players set mgice ally.anim_tick 0

# boss.storage2 animation cooldown
execute if score mgice boss.storage2 matches 1.. run scoreboard players remove mgice boss.storage2 1
# boss.storage1 attack cooldown
execute if score mgice boss.storage1 matches 1.. run scoreboard players remove mgice boss.storage1 1

execute if score mgice boss.battle_tick matches 1.. if score mgice boss.storage2 matches ..1 if entity @e[tag=mgice_core,tag=!attack,tag=!dying] run execute as @e[tag=mandragigas.root] at @s run function mandragigas:animations/idle/next_frame


#targetting system
execute if score worldScore wtc_10 matches 9.. run function ampsurv:boss/mandragigas-ice/system/targetting
#tp facing target
execute as @e[tag=mgice_core,type=armor_stand] at @s run tp @s ~ ~ ~ facing entity @e[tag=mgice_target,type=#ally,limit=1,sort=nearest]
execute as @e[tag=mandragigas.root,type=marker] at @s run tp @s ~ ~ ~ facing entity @e[tag=mgice_target,type=#ally,limit=1,sort=nearest]

#choose attack
execute as @e[tag=mgice_core,type=armor_stand,tag=!attack,tag=!dying] at @s if score mgice boss.storage2 matches ..1 if score mgice boss.storage1 matches ..1 if score mgice boss.battle_tick matches 1.. run function ampsurv:boss/mandragigas-ice/attacks/phases/manager

#loops
execute if entity @e[tag=mgice_m1_hitbox,type=area_effect_cloud] run function ampsurv:boss/mandragigas-ice/attacks/hitbox/m_atk1
execute if entity @e[tag=mgice_m2_hitbox,type=area_effect_cloud] run function ampsurv:boss/mandragigas-ice/attacks/hitbox/m_atk2
execute if entity @e[tag=mgice_s1_hitbox,type=area_effect_cloud] run function ampsurv:boss/mandragigas-ice/attacks/hitbox/ice-aura-box
execute as @e[tag=ice-aura,type=armor_stand,tag=mgice_core] at @s run function ampsurv:boss/mandragigas-ice/attacks/ice-aura/loop
execute if entity @e[tag=mgice_r1_hitbox,type=area_effect_cloud] at @s run function ampsurv:boss/mandragigas-ice/attacks/hitbox/r_atk1
execute if entity @e[tag=mgice_r2_hitbox,type=area_effect_cloud] at @s run function ampsurv:boss/mandragigas-ice/attacks/hitbox/r_atk2
execute if entity @e[tag=mgice_s2_hitbox,type=area_effect_cloud] at @s run function ampsurv:boss/mandragigas-ice/attacks/newmoon/loop
execute if entity @e[tag=mgice_nnm_spirit,type=vex] at @s run function ampsurv:boss/mandragigas-ice/attacks/newmoon/spirits

#percent detections
#75%
execute as @e[tag=mgice_core,type=armor_stand,tag=!75_percent] if score mgice boss.storage.mgice matches ..450 run function ampsurv:boss/mandragigas-ice/system/percent_detect/75
#50%
execute as @e[tag=mgice_core,type=armor_stand,tag=!50_percent] if score mgice boss.storage.mgice matches ..300 run function ampsurv:boss/mandragigas-ice/system/percent_detect/50

#death
execute as @e[tag=mgice_core,tag=!dying] at @s unless entity @e[tag=mgice_entity,distance=..10,type=elder_guardian] run tellraw @a[distance=..50] ["",{"text":"\n"},{"text":"\u1360","color":"dark_red"},{"text":" Ice Mandragigas","bold":true,"color":"red"},{"text":" has been defeated!","color":"dark_red"},{"text":"\n "}]
execute as @e[tag=mgice_core,tag=!dying] at @s unless entity @e[tag=mgice_entity,distance=..10,type=elder_guardian] run scoreboard players set mgice boss.battle_tick 611
execute as @e[tag=mgice_core,tag=!dying] at @s unless entity @e[tag=mgice_entity,distance=..10,type=elder_guardian] run tag @s add dying

execute if entity @s[tag=dying] run function ampsurv:boss/mandragigas-ice/system/defeat
