#skill Meteoric Shower Animation and scripts

#Meteoric Shower - Opening Blast
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=214..224}] run tp @s ^ ^ ^1.5 facing entity @e[tag=oldmage_battle_center,limit=1,sort=nearest]
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=214..224}] unless entity @e[tag=oldmage_dash_anim,distance=..3] run summon armor_stand ^ ^ ^-2 {Tags:["oldmage_dash_anim"],Pose:{Head:[15f,0f,0f],RightArm:[10f,46f,20f],LeftArm:[360f,0f,341f],LeftLeg:[360f,0f,350f],RightLeg:[0f,0f,10f]},Invisible:1b,Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Marker:1b,ArmorItems:[{id:"leather_boots",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1,display:{color:4785234}}},{id:"leather_leggings",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1,display:{color:4785234}}},{id:"leather_chestplate",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1,display:{color:4785234}}},{}],HandItems:[{},{}]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=214..224}] unless entity @e[tag=oldmage_dash_anim_cd] run summon area_effect_cloud ~ ~ ~ {Duration:20,Tags:["oldmage_dash_anim_cd"]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=224}] run data modify entity @s Pose{} set value {Head:[350f,0f,0f],RightArm:[10f,46f,20f],LeftArm:[360f,0f,341f],LeftLeg:[360f,0f,350f],RightLeg:[0f,0f,10f]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=234}] run data modify entity @s Pose{} set value {Head:[355f,0f,0f],RightArm:[330f,0f,10f],LeftArm:[300f,2f,310f]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=244}] run data modify entity @s Pose{} set value {Head:[0f,0f,0f],RightArm:[272f,331f,0f],LeftArm:[241f,4f,270f]}

execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=224..264}] run summon area_effect_cloud ~ ~ ~5 {Duration:20,Tags:["meteor_blast_anim"]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=224..264}] run summon area_effect_cloud ~ ~ ~-5 {Duration:20,Tags:["meteor_blast_anim"]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=224..264}] run summon area_effect_cloud ~5 ~ ~ {Duration:20,Tags:["meteor_blast_anim"]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=224..264}] run summon area_effect_cloud ~-5 ~ ~ {Duration:20,Tags:["meteor_blast_anim"]}
execute as @e[tag=meteor_blast_anim] at @s if entity @p[tag=host,scores={boss.battle_tick=224..264}] run tp @s ^2.7 ^ ^1 facing entity @e[tag=oldmage_head,sort=nearest,limit=1]
execute as @e[tag=meteor_blast_anim] at @s if entity @p[tag=host,scores={boss.battle_tick=224..264}] run playsound minecraft:entity.zombie_villager.converted player @a[distance=..8] ~ ~ ~ 0.2 2 0.1
execute as @e[tag=meteor_blast_anim] at @s if entity @p[tag=host,scores={boss.battle_tick=264..284}] run playsound minecraft:entity.zombie_villager.cure player @a[distance=..3] ~ ~ ~ 0.1 0 0.1
execute as @e[tag=meteor_blast_anim] at @s if entity @p[tag=host,scores={boss.battle_tick=224..264}] run playsound minecraft:entity.elder_guardian.ambient player @a[distance=..8] ~ ~ ~ 0.2 2 0.1
execute as @e[tag=meteor_blast_anim] at @s run particle dust 0.2 0 0.4 1 ~ ~1 ~ 0.2 0.2 0.2 1 5 force
execute as @e[tag=meteor_blast_anim] at @s if entity @p[tag=host,scores={boss.battle_tick=264..284}] run tp @s ^ ^ ^-1
execute as @e[tag=meteor_blast_anim] at @s if entity @p[tag=host,scores={boss.battle_tick=264..284}] run effect give @e[type=#ally,distance=..10] instant_damage 1 1 true

execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=264}] run data modify entity @s Pose{} set value {RightArm:[0f,0f,89f],LeftArm:[351f,0f,290f],RightLeg:[0f,17f,16f],LeftLeg:[360f,273f,334f]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=264}] run data modify entity @e[tag=oldmage_feet,limit=1,sort=nearest] Pose{} set value {RightLeg:[0f,17f,16f],LeftLeg:[360f,273f,334f]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=264}] run data modify entity @e[tag=oldmage_head,limit=1,sort=nearest] Pose{} set value {Head:[46f,0f,0f]}
#Meteoric Shower - The Shower
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=300..301}] run tellraw @a {"text":"Beware the Arcanum Shower!","color":"yellow","bold":true}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=300..}] run data modify entity @e[tag=oldmage_feet,limit=1,sort=nearest] Pose{} set value {RightLeg:[9f,30f,0f],LeftLeg:[0f,0f,0f]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=300..}] run data modify entity @e[tag=oldmage_head,limit=1,sort=nearest] Pose{} set value {Head:[345f,333f,0f]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=302}] run data modify entity @s Pose{} set value {Head:[180f,0f,0f],RightLeg:[9f,30f,0f],LeftArm:[331f,340f,290f],RightArm:[3f,11f,79f]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=304}] run data modify entity @s Pose{} set value {Head:[180f,0f,0f],RightLeg:[9f,30f,0f],LeftArm:[316f,320f,285f],RightArm:[3f,11f,79f]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=306}] run data modify entity @s Pose{} set value {Head:[180f,0f,0f],RightLeg:[9f,30f,0f],LeftArm:[300f,315f,280f],RightArm:[7f,22f,55f]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=308}] run data modify entity @s Pose{} set value {Head:[180f,0f,0f],RightLeg:[9f,30f,0f],LeftArm:[287f,320f,280f],RightArm:[10f,33f,45f]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=310}] run data modify entity @s Pose{} set value {Head:[180f,0f,0f],RightLeg:[9f,30f,0f],LeftArm:[277f,325f,275f],RightArm:[13f,40f,25f]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=313}] run data modify entity @s Pose{} set value {Head:[180f,0f,0f],RightLeg:[9f,30f,0f],LeftArm:[267f,331f,275f],RightArm:[15f,44f,14f]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=313..}] run tp @s ~ ~0.05 ~
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=313..}] run summon area_effect_cloud ~ ~ ~ {Duration:1,Tags:["shower_target"]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=313..}] run summon area_effect_cloud ~ ~ ~ {Duration:1,Tags:["shower_target"]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=313..}] run summon area_effect_cloud ~ ~ ~ {Duration:1,Tags:["shower_target"]}
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=313..}] run spreadplayers ~ ~ 0.1 20 under 30 true @e[tag=shower_target,type=area_effect_cloud,distance=..20]
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=313..}] run playsound entity.zombie_villager.converted ambient @a[distance=..30] ~ ~ ~ 1 0 0

