
#bobe-----------------------------------------------------------------------------------
effect give @e[tag=bobe_Entity,type=snow_golem] invisibility 999999 0 true
effect give @e[tag=bobe_Entity,type=snow_golem] fire_resistance 999999 0 true
execute as @e[tag=bobe_Entity,type=snow_golem] at @s unless entity @e[type=#enemy,distance=..25] run effect give @e[tag=bobe_Entity,type=snow_golem] slowness 2 2 true

execute as @e[tag=bobe_Entity,type=snow_golem] at @s run tag @e[type=snowball,distance=..2] add bobe_reg_atk
execute as @e[tag=bobe_Entity,type=snow_golem] at @s unless entity @e[tag=bobe_Model,distance=..2] run function bow_hero:summon/default
execute as @e[tag=bobe_Model,type=marker] at @s unless entity @e[tag=bobe_Entity,type=snow_golem,distance=..2] run function bow_hero:remove/this

execute as @e[tag=bobe_Entity,type=snow_golem] at @s unless entity @e[tag=bobe_name,distance=..3] run summon armor_stand ~ ~ ~ {NoGravity:1b,Marker:1b,Invisible:true,CustomName:'[{"text":"Bobe, Defender Of The Deep","bold":true,"color":"red"}]',CustomNameVisible:1b,Tags:["bobe_name"]}
execute as @e[tag=bobe_Model,type=marker] at @s run tp @e[tag=bobe_name,limit=1,sort=nearest] ~ ~2 ~

execute as @e[tag=bobe_Entity,type=snow_golem] at @s run tp @e[tag=bobe_Model,sort=nearest,limit=1] ^ ^ ^-0.1 facing entity @s

execute as @e[tag=bobe_Entity,type=snow_golem] at @s unless entity @e[tag=bobe_dd] run summon area_effect_cloud ~ ~ ~ {Duration:2147483647,Tags:["bobe_dd","hero_dd"]}

#greet
execute as @e[tag=bobe_Entity,tag=!greeted_player,type=snow_golem] at @s unless entity @e[type=#enemy,distance=..25] if entity @p[distance=..4] run tellraw @a[distance=..10,scores={ally.anim_tick=0..7}] ["",{"text":"<","color":"white"},{"text":"Sir Bobe","bold":true,"color":"green"},{"text":"> They will not breach these walls! ","color":"white"}]
execute as @e[tag=bobe_Entity,tag=!greeted_player,type=snow_golem] at @s unless entity @e[type=#enemy,distance=..25] if entity @p[distance=..4] run tellraw @a[distance=..10,scores={ally.anim_tick=8..15}] ["",{"text":"<","color":"white"},{"text":"Sir Bobe","bold":true,"color":"green"},{"text":"> I've come all the way from Rohan to fight by your side, ","color":"white"},{"selector":"@p","color":"white"},{"text":".","color":"white"}]
execute as @e[tag=bobe_Entity,tag=!greeted_player,type=snow_golem] at @s unless entity @e[type=#enemy,distance=..25] if entity @p[distance=..4] run tellraw @a[distance=..10,scores={ally.anim_tick=16..23}] ["",{"text":"<","color":"white"},{"text":"Sir Bobe","bold":true,"color":"green"},{"text":"> Your friends are with you ","color":"white"},{"selector":"@p","color":"white"},{"text":".","color":"white"}]
execute as @e[tag=bobe_Entity,tag=!greeted_player,type=snow_golem] at @s unless entity @e[type=#enemy,distance=..25] if entity @p[distance=..4] run tellraw @a[distance=..10,scores={ally.anim_tick=24..30}] ["",{"text":"<","color":"white"},{"text":"Sir Bobe","bold":true,"color":"green"},{"text":"> You should check out the","color":"white"},{"text":" [","color":"yellow"},{"text":"Hornburg","color":"yellow","clickEvent":{"action":"open_url","value":"https://www.planetminecraft.com/project/defend-helms-deep/"},"hoverEvent":{"action":"show_text","contents":"Link to _BOBE's map: Defend Helm's Deep"}},{"text":"] ","color":"yellow"},{"text":"at this time of year.","color":"white"}]
execute as @e[tag=bobe_Entity,tag=!greeted_player,type=snow_golem] at @s unless entity @e[type=#enemy,distance=..25] if entity @p[distance=..4] run tp @s ~ ~ ~ facing entity @p
execute as @e[tag=bobe_Entity,tag=!greeted_player,type=snow_golem] at @s unless entity @e[type=#enemy,distance=..25] if entity @p[distance=..4] run effect give @s slowness 1 255 true
execute as @e[tag=bobe_Entity,type=snow_golem] at @s unless entity @e[type=#enemy,distance=..20] if entity @a[distance=..4] run tag @s add greeted_player
execute as @e[tag=bobe_Entity,type=snow_golem] at @s unless entity @e[type=#enemy,distance=..20] unless entity @p[distance=..10] run tag @s remove greeted_player
#hurt
execute as @e[tag=bobe_Entity,type=snow_golem,tag=hurt] at @s run playsound entity.generic.hurt neutral @a[distance=..5] ~ ~ ~ 1 1 0
execute as @e[tag=bobe_Entity,type=snow_golem,tag=hurt] at @s run particle angry_villager ~ ~1.5 ~ 0.3 0.3 0.3 0 3 normal

#Attacking
execute as @e[tag=bobe_Model,type=marker] at @s if entity @e[tag=bobe_Proj,distance=..3.5] run execute as @e[limit=1,sort=nearest,tag=bobe_Model] if entity @e[type=#enemy,distance=..25] run function bow_hero:animations/b_attack1/play
execute as @e[tag=bobe_Model] at @s if entity @e[tag=bobe_Proj,distance=..3.5] run execute as @e[limit=1,sort=nearest,tag=bobe_Model] if entity @e[type=#enemy,distance=..25] run function bow_hero:animations/b_attack2/stop
execute as @e[tag=bobe_Model] at @s if entity @e[tag=bobe_Proj_skill,distance=..3.5] run execute as @e[limit=1,sort=nearest,tag=bobe_Model] if entity @e[type=#enemy,distance=..25] run function bow_hero:animations/b_attack2/play
execute as @e[tag=bobe_Model] at @s if entity @e[tag=bobe_arrow,distance=..3] run tp @s ~ ~ ~ facing entity @e[type=#enemy,sort=nearest,limit=1]

#walking animation
execute as @e[tag=bobe_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]}] at @s run execute as @e[limit=1,sort=nearest,tag=bobe_Model] if entity @e[type=#enemy,distance=..25] run function bow_hero:animations/b_pursue/next_frame
execute as @e[tag=bobe_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]}] at @s run execute as @e[limit=1,sort=nearest,tag=bobe_Model] unless entity @e[type=#enemy,distance=..25] run function bow_hero:animations/b_walk_idle/next_frame
execute as @e[tag=bobe_Entity,nbt={Motion:[0.0d,0.0d,0.0d]}] at @s unless entity @e[type=#enemy,distance=..10,tag=!hurt] run execute as @e[limit=1,sort=nearest,tag=bobe_Model] run function bow_hero:animations/idle/next_frame

#Attack particles and effects
execute as @e[tag=bobe_Entity,type=snow_golem,tag=!skill] at @s run function ampsurv:entity/ally/skills/bobe_atk_reg
execute as @e[tag=bobe_Entity,type=snow_golem,tag=skill] at @s run function ampsurv:entity/ally/skills/bobe_atk_skill

#skill-dashback
execute as @e[tag=bobe_Entity,type=snow_golem,tag=!skill] at @s if entity @e[type=#enemy,distance=..10] unless entity @e[tag=bobe_skill_cd,type=area_effect_cloud] run function ampsurv:entity/ally/skills/bobe-dash
execute as @e[tag=bobe_Entity,type=snow_golem,tag=skill] at @s unless entity @e[tag=bobe_skill_duration,type=area_effect_cloud] run tag @s remove skill
execute as @e[tag=bobe_Entity,type=snow_golem,tag=skill] at @s if entity @e[tag=bobe_skill_animating,type=area_effect_cloud] run execute as @e[tag=bobe_Model,limit=1,sort=nearest] run function bow_hero:animations/bobe_skill/next_frame
execute as @e[tag=bobe_Entity,type=snow_golem,tag=skill] at @s run particle dust_color_transition 0.1 0.7 0 1 0 0.7 0 ~ ~1 ~ 0.2 0.5 0.2 0.2 10 normal
