# Captain Jekk
#---------------------------------------------------------------------------------------------
effect give @e[tag=jekk_Entity,type=iron_golem] invisibility 999999 0 true
execute as @e[tag=jekk_Entity,type=iron_golem] at @s unless entity @e[tag=jekk_Model,distance=..2] run function jekk:summon/default
execute as @e[tag=jekk_Entity,type=iron_golem] at @s unless entity @e[tag=jekk_name,distance=..3] run summon armor_stand ~ ~2 ~ {NoGravity:1b,Marker:1b,Invisible:true,CustomName:'[{"text":"Arbiter Knight Jekk","bold":true,"color":"red"}]',CustomNameVisible:1b,Tags:["jekk_name"]}
execute as @e[tag=jekk_Model] at @s run tp @e[tag=jekk_name,limit=1,sort=nearest] ~ ~2 ~

execute as @e[tag=jekk_Entity,type=iron_golem] at @s if entity @e[type=#enemy,distance=..20] run tp @e[tag=jekk_Model,sort=nearest,limit=1] ^ ^ ^ facing entity @e[type=#enemy,sort=nearest,distance=..10,limit=1]
execute as @e[tag=jekk_Entity,type=iron_golem] at @s unless entity @e[type=#enemy,distance=..20] run tp @e[tag=jekk_Model,sort=nearest,limit=1] ^ ^ ^ facing entity @p
execute as @e[tag=jekk_Model] at @s unless entity @e[tag=jekk_Entity,type=iron_golem,distance=..2] run function jekk:remove/this

execute as @e[tag=jekk_Entity,type=iron_golem] at @s unless entity @e[tag=jekk_dd] run summon area_effect_cloud ~ ~ ~ {Duration:2147483647,Tags:["jekk_dd","hero_dd"]}
#reset pose
execute as @e[tag=jekk_Entity,type=iron_golem,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4,scores={ally.anim_tick=0..10}] run tellraw @a[distance=..10] ["",{"text":"<","color":"white"},{"text":"Captain Jekk","bold":true,"color":"green"},{"text":"> Let's stay vigilant, ","color":"white"},{"selector":"@p","color":"white"},{"text":" !","color":"white"}]
execute as @e[tag=jekk_Entity,type=iron_golem,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4,scores={ally.anim_tick=11..20}] run tellraw @a[distance=..10] ["",{"text":"<","color":"white"},{"text":"Captain Jekk","bold":true,"color":"green"},{"text":"> How's your day been, ","color":"white"},{"selector":"@p","color":"white"},{"text":" ?","color":"white"}]
execute as @e[tag=jekk_Entity,type=iron_golem,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4,scores={ally.anim_tick=21..30}] run tellraw @a[distance=..10] ["",{"text":"<","color":"white"},{"text":"Captain Jekk","bold":true,"color":"green"},{"text":"> Report to me if you catch anything out of the ordinary, ","color":"white"},{"selector":"@p","color":"white"},{"text":" !","color":"white"}]
execute as @e[tag=jekk_Entity,type=iron_golem,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4] run tp @s ~ ~ ~ facing entity @p[distance=..4,limit=1,gamemode=!spectator]
execute as @e[tag=jekk_Entity,type=iron_golem,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4] run effect give @s slowness 1 255 true
#execute as @e[tag=jekk_Entity,type=iron_golem,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4] run execute as @e[tag=jekk_Model,limit=1,sort=nearest] run function jekk:animations/skill/play
execute as @e[tag=jekk_Entity,type=iron_golem,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4] run tag @s add greeted_player
execute as @e[tag=jekk_Entity,type=iron_golem] at @s unless entity @e[type=#enemy,distance=..20] unless entity @p[distance=..10] run tag @s remove greeted_player
#hurt
execute as @e[tag=jekk_Entity,type=iron_golem,tag=hurt] at @s run playsound entity.generic.hurt neutral @a[distance=..5] ~ ~ ~ 1 1 0
execute as @e[tag=jekk_Entity,type=iron_golem,tag=hurt] at @s run particle angry_villager ~ ~1.5 ~ 0.3 0.3 0.3 0 3 normal
#execute as @e[tag=jekk_Entity,type=iron_golem,tag=hurt] at @s run tellraw @a[distance=..5,scores={ally.anim_tick=21..30}] ["",{"text":"<","color":"white"},{"text":"Captain Jekk","bold":true,"color":"green"},{"text":"> Hm!","color":"white"}]
#execute as @e[tag=jekk_Entity,type=iron_golem,tag=hurt] at @s run tellraw @a[distance=..5,scores={ally.anim_tick=11..20}] ["",{"text":"<","color":"white"},{"text":"Captain Jekk","bold":true,"color":"green"},{"text":"> You Fool!","color":"white"}]
#execute as @e[tag=jekk_Entity,type=iron_golem,tag=hurt] at @s run tellraw @a[distance=..5,scores={ally.anim_tick=0..10}] ["",{"text":"<","color":"white"},{"text":"Captain Jekk","bold":true,"color":"green"},{"text":"> That does nothing!","color":"white"}]
#Attacking
#execute as @e[tag=jekk_Model] at @s if entity @e[type=#enemy,distance=..10,tag=!hurt] run data modify entity @s Pose{} merge value {RightArm:[24f,44f,34f],LeftArm:[280f,26f,0f]}
execute as @e[tag=jekk_Model] at @s if entity @e[type=#enemy,distance=..3,tag=hurt] if entity @p[scores={ally.anim_tick=0..15}] run function jekk:animations/attack1/play
execute as @e[tag=jekk_Model] at @s if entity @e[type=#enemy,distance=..3,tag=hurt] if entity @p[scores={ally.anim_tick=16..30}] run function jekk:animations/attack2/play
execute as @e[tag=jekk_Model] at @s if entity @e[type=#enemy,distance=..3,tag=hurt] run particle sweep_attack ^ ^1 ^1.5 0.1 0.1 0.1 0 1 normal
execute as @e[tag=jekk_Model] at @s if entity @e[type=#enemy,distance=..3,tag=hurt] run playsound entity.player.attack.sweep neutral @a[distance=..10] ~ ~ ~ 1 1 0
#walking animation
execute as @e[tag=jekk_Entity,type=iron_golem,nbt=!{Motion:[0.0d,0.0d,0.0d]}] at @s run execute as @e[limit=1,sort=nearest,tag=jekk_Model] if entity @e[type=#enemy,distance=..20] run function jekk:animations/walking_offense/next_frame
execute as @e[tag=jekk_Entity,type=iron_golem,nbt=!{Motion:[0.0d,0.0d,0.0d]}] at @s run execute as @e[limit=1,sort=nearest,tag=jekk_Model] unless entity @e[type=#enemy,distance=..20] run function jekk:animations/walk_idle/next_frame
execute as @e[tag=jekk_Entity,type=iron_golem,nbt={Motion:[0.0d,0.0d,0.0d]}] at @s unless entity @e[type=#enemy,distance=..10,tag=hurt] run execute as @e[limit=1,sort=nearest,tag=jekk_Model] run function jekk:animations/idle/next_frame

#scrounged chance and particles and effects
execute as @e[tag=jekk_Entity,type=iron_golem,tag=hurt,nbt=!{ActiveEffects:[{Id:22b}]}] at @s if entity @p[scores={ally.anim_tick=5..10}] run function ampsurv:entity/ally/jekk-skill
execute as @e[tag=jekk_Entity,type=iron_golem,nbt={ActiveEffects:[{Id:22b}]}] at @s run particle minecraft:witch ~ ~0.4 ~ 0.2 0.4 0.2 0 15 normal
execute as @e[tag=jekk_Entity,type=iron_golem,nbt={ActiveEffects:[{Id:22b}]}] at @s run playsound minecraft:entity.elder_guardian.ambient ambient @a[distance=..5] ~ ~ ~ 0.3 1.2 0.3
execute as @e[tag=jekk_Entity,type=iron_golem,tag=hurt,nbt=!{ActiveEffects:[{Id:10b}]},nbt={ActiveEffects:[{Id:22b}]}] at @s run effect give @s regeneration 3 2 true
execute as @e[tag=jekk_Entity,type=iron_golem,nbt={ActiveEffects:[{Id:22b}]}] at @s if entity @p[scores={ally.anim_tick=25..27}] run execute as @e[tag=jekk_Model,limit=1,sort=nearest] run function jekk:animations/skill/stop
#Respawn Mechanic
#-------------------------------------------------------------------------------------------